> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Create Webhook

POST https://api.bigcommerce.com/stores/{store_hash}/v3/hooks
Content-Type: application/json

Creates a webhook. Only one webhook at a time can be created. Custom headers can be added. Destination URL must be served on port 443 (custom ports are not currently supported).

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/integrations/webhooks/create-webhooks

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes None required. Create and manage webhooks with the default scope of an API account. ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Headers

- `Accept` (string, optional, default: application/json) — The MIME type of the response body that the client accepts. Typically `application/json`.

### Body (application/json)

This endpoint expects a webhook_Base.

- `scope` (string, required) — Event you subscribe to.
- `destination` (string, required) — URL must be active, return a 200 response, and be served on port 443. Custom ports arenʼt currently supported.
- `is_active` (boolean, optional) — Boolean value that indicates whether the webhook is active or not. A webhook subscription becomes deactivated after 90 days of inactivity.
- `headers` (WebhookBaseHeaders, optional, nullable) — Headers used to validate that webhooks are active. You can pass in any number of custom headers to validate webhooks are being returned.

## Response

### 200

OK

- `data` (webhook_Full, optional)
- `meta` (any, optional)

## Errors

### 400 Bad Request Error

Malformed request syntax. Typically need to fix the JSON request body to resend successfully.

- `status` (integer, optional) — The HTTP status code.
- `title` (string, optional) — The error title describing the particular error.
- `type` (string, optional) — This value is typically a link to BigCommerce API Status codes.

### 401 Unauthorized Error

Unauthorized - the v3 Auth client ID or token in the request are not a valid combination for this store.

- `status` (integer, optional) — The HTTP status code.
- `title` (string, optional) — The error title describing the particular error.
- `type` (string, optional) — This value is typically a link to BigCommerce API Status codes.

### 422 Unprocessable Entity Error

This occurs when missing or unacceptable data is passed for one or more fields. Please correct the values for the fields listed in the errors object.

- `status` (integer, optional) — The HTTP status code.
- `title` (string, optional) — The error title describing the particular error.
- `type` (string, optional) — Typically a link to BigCommerce API Status codes
- `errors` (any, optional)

## Types

### WebhookBaseHeaders

Headers used to validate that webhooks are active. You can pass in any number of custom headers to validate webhooks are being returned.

### webhook_Full

- `scope` (string, required) — Event you subscribe to.
- `destination` (string, required) — URL must be active, return a 200 response, and be served on port 443. Custom ports arenʼt currently supported.
- `id` (integer, optional) — ID of the webhook.
- `client_id` (string, optional) — Client ID, unique to the store or app.
- `store_hash` (string, optional) — Permanent ID of the BigCommerce store.
- `created_at` (integer, optional) — The time the webhook was created, represented in UNIX epoch time.
- `updated_at` (integer, optional) — The time the webhook was most recently updated, represented in UNIX epoch time.
- `is_active` (boolean, optional) — Boolean value that indicates whether the webhook is active or not. A webhook subscription becomes deactivated after 90 days of inactivity.
- `headers` (WebhookFullHeaders, optional, nullable) — Headers used to validate that webhooks are active. You can pass in any number of custom headers to validate webhooks are being returned.

### WebhookFullHeaders

Headers used to validate that webhooks are active. You can pass in any number of custom headers to validate webhooks are being returned.

## Examples

**Request**

```json
{
  "scope": "store/order/created",
  "destination": "https://665b65a6.ngrok.io/webhooks"
}
```

**Response**

```json
{
  "data": {
    "scope": "store/order/created",
    "destination": "https://665b65a6.ngrok.io/webhooks",
    "id": 18048287,
    "client_id": "m9r6keqmo7h7f23btnpwernbez1kglkl",
    "store_hash": "sftg45fsd",
    "created_at": 1561488106,
    "updated_at": 1561488106,
    "is_active": true,
    "headers": {}
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/hooks"

payload = {
    "scope": "store/order/created",
    "destination": "https://665b65a6.ngrok.io/webhooks"
}
headers = {
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/hooks';
const options = {
  method: 'POST',
  headers: {'X-Auth-Token': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"scope":"store/order/created","destination":"https://665b65a6.ngrok.io/webhooks"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/hooks"

	payload := strings.NewReader("{\n  \"scope\": \"store/order/created\",\n  \"destination\": \"https://665b65a6.ngrok.io/webhooks\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/hooks")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"scope\": \"store/order/created\",\n  \"destination\": \"https://665b65a6.ngrok.io/webhooks\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.bigcommerce.com/stores/store_hash/v3/hooks")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"scope\": \"store/order/created\",\n  \"destination\": \"https://665b65a6.ngrok.io/webhooks\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.bigcommerce.com/stores/store_hash/v3/hooks', [
  'body' => '{
  "scope": "store/order/created",
  "destination": "https://665b65a6.ngrok.io/webhooks"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/hooks");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"scope\": \"store/order/created\",\n  \"destination\": \"https://665b65a6.ngrok.io/webhooks\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "scope": "store/order/created",
  "destination": "https://665b65a6.ngrok.io/webhooks"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/hooks")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```